<template>
    <div class="container w-80 mx-auto mt-36">
        <Input v-model="email" label="email" :error="emailError"/>
        <Input v-model="password" label="password" :error="passwordError"/>
        <div class="relative h-3">
            <p v-if="loginError" class="absolute w-full text-center text-sm text-red-700">
                {{ loginError }}. Please, try again.
            </p>
        </div>
        <div class="flex flex-row justify-between pt-8 pb-8">
            <Button button-label="clear" @clicked="onClickClear"/>
            <Button button-label="sign in" @clicked="onClickSignIn"/>
        </div>
        <p class="text-center text-sm text-gray-700">
            Not a user yet?
            <router-link class="text-blue-400 underline" to="/sign-up">Sign up</router-link>
            now!
        </p>
    </div>
</template>

<script>
import { mapMutations, mapState } from 'vuex';

const baseURL = "http://localhost:3001/";

export default {
    data() {
        return {
            emailError: "",
            passwordError: "",
            loginError: "",
            email: null,
            password: null,
        };
    },
    computed: {
        ...mapState({
            token: state => state.token,
            userId: state => state.userId,
        }),
    },
    methods: {
        ...mapMutations({
            setToken: 'set',
        }),
        async loginUser() {
            try {
                const res = await this.$axios.post(baseURL + "login/", {
                    email: this.email,
                    password: this.password,
                });
                this.setToken(res.data.accessToken);
                this.$router.push({"name": "users-id", params: { id: this.userId }});
            } catch(e) {
                this.loginError = e.response.data;
            }
        },
        clear() {
            this.email = "";
            this.password = "";
            this.clearErrors();
        },
        clearErrors() {
            this.emailError = "";
            this.passwordError = "";
            this.loginError = "";
        },
        onClickClear() {
            this.clear();
        },
        onClickSignIn() {
            this.clearErrors();
            if (this.isFormValid()) {
                this.loginUser();
            }
        },
        isFormValid() {
            // Email validation.
            const emailRegex = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;

            if (!this.email) {
                this.emailError = "Email required";
            }
            else if (!emailRegex.test(String(this.email).toLowerCase())) {
                this.emailError = "Invalid email";
            }

            // Password validation.
            if (!this.password) {
                this.passwordError = "Password required.";
            }
            else if (this.password.length < 8) {
                this.passwordError = "Password too short.";
            }
            else if (this.password.length > 32) {
                this.passwordError = "Password too long.";
            }

            if (this.emailError.length > 0 ||
                this.passwordError.length > 0) {
                return false;
            }
            return true;
        },
    },
};
</script>
